com.io7m.jpra.compiler.core.checker

## Class JPRAChecker

- java.lang.Object
- - com.io7m.jpra.compiler.core.checker.JPRAChecker

- All Implemented Interfaces:
    JPRACheckerType

      public final class JPRAChecker
      extends Object
      implements JPRACheckerType

  The default implementation of the `JPRACheckerType` interface.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `StatementCommandType<IdentifierType,TType>` | `checkCommandType(StatementCommandType<IdentifierType,Untyped> s)` Check a `:type` command.
    `void` | `checkPackageBegin(StatementPackageBegin<IdentifierType,Untyped> s)` Check a package begin statement.
    `PackageContextType` | `checkPackageEnd(StatementPackageEnd<IdentifierType,Untyped> s)` Complete the current package.
    `TypeDeclType<IdentifierType,TType>` | `checkTypeDeclaration(TypeDeclType<IdentifierType,Untyped> decl)` Check a type declaration.
    `TypeExprType<IdentifierType,TType>` | `checkTypeExpression(TypeExprType<IdentifierType,Untyped> expr)` Check a type expression.
    `static JPRACheckerType` | `newChecker(GlobalContextType c, JPRACheckerCapabilitiesType caps)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### newChecker

          public static JPRACheckerType newChecker(GlobalContextType c,
                                                   JPRACheckerCapabilitiesType caps)

      Parameters:
        `c` - A global context
        `caps` - The capabilities that will be enforced
      Returns:
        A new resolver

    - #### checkPackageBegin

          public void checkPackageBegin(StatementPackageBegin<IdentifierType,Untyped> s)
                                 throws JPRACompilerCheckerException

      Description copied from interface: `JPRACheckerType`
      Check a package begin statement.
      Specified by:
        `checkPackageBegin` in interface `JPRACheckerType`
      Parameters:
        `s` - The statement
      Throws:
        `JPRACompilerCheckerException` - On resolution errors

    - #### checkPackageEnd

          public PackageContextType checkPackageEnd(StatementPackageEnd<IdentifierType,Untyped> s)
                                             throws JPRACompilerCheckerException

      Description copied from interface: `JPRACheckerType`
      Complete the current package.
      Specified by:
        `checkPackageEnd` in interface `JPRACheckerType`
      Parameters:
        `s` - The statement
      Returns:
        A completed package context
      Throws:
        `JPRACompilerCheckerException` - On resolution errors

    - #### checkTypeDeclaration

          public TypeDeclType<IdentifierType,TType> checkTypeDeclaration(TypeDeclType<IdentifierType,Untyped> decl)
                                                                  throws JPRACompilerCheckerException

      Description copied from interface: `JPRACheckerType`
      Check a type declaration.
      Specified by:
        `checkTypeDeclaration` in interface `JPRACheckerType`
      Parameters:
        `decl` - The input declaration
      Returns:
        A type declaration
      Throws:
        `JPRACompilerCheckerException` - On type errors

    - #### checkTypeExpression

          public TypeExprType<IdentifierType,TType> checkTypeExpression(TypeExprType<IdentifierType,Untyped> expr)
                                                                 throws JPRACompilerCheckerException

      Description copied from interface: `JPRACheckerType`
      Check a type expression.
      Specified by:
        `checkTypeExpression` in interface `JPRACheckerType`
      Parameters:
        `expr` - The input expression
      Returns:
        A type expression
      Throws:
        `JPRACompilerCheckerException` - On type errors

    - #### checkCommandType

          public StatementCommandType<IdentifierType,TType> checkCommandType(StatementCommandType<IdentifierType,Untyped> s)
                                                                      throws JPRACompilerCheckerException

      Description copied from interface: `JPRACheckerType`
      Check a `:type` command.
      Specified by:
        `checkCommandType` in interface `JPRACheckerType`
      Parameters:
        `s` - The statement
      Returns:
        A type expression
      Throws:
        `JPRACompilerCheckerException` - On type errors

Copyright © 2016 <code@io7m.com> http://io7m.com